class Keeper{
    constructor(){
        this.token = null;
        this.socket = null;
        
        this.user ={
            inBattle: false,
            isReady: false,
            login: null,
        };
        this.enemy = {
            login:null,
        }
        this.world = null;
        this.inBattle = false;
        this.inReady = false;
        this.collection = [];
        this.lastLevel = null;
        this.set = [];
        this.battle = {
            info: { 
                status: null,
                turnNumber: 0
            },
            data:{
                helpArtifactsId:null,
                helpCreaturesId:null,
                turnNumber:null,
                ourCreatures:[],
                ourArtifacts:[],
                enemyCreatures:[],
                enemyArtifacts:[],
            },
            result:{
                win:null,
                winner:null,
                winArtifacts:null,
                loseArtifacts:null,
                battleTime:null,
                getExperience:0,
            }
        };
        this.timers = {
            leftJoinTime:null,
            leftChangeQuestTime:null,
            battle:
            {
                leftJoinTime:null,
                lastPrepeareTime:null,
                lastSelectionTime:null,
                currentPhaseLastTime:null,
                leftPercentTurnTime:null,
            }
        };
        this.authData = {
            registration: false,
            login : null,
            password: null,
            email : null,
        };
        this.serverStatus = 'Offline';    
        this.dataIsLoad = false;
        
        this.chat = {
            all:[],
            private:[],
        }
    }
    createRandomArtifactSet(){
        let newCollection = this.getAllUniqueCollection();
        let newSet = [];
        console.log(newCollection)
        if(newCollection.length >= 7){
            let setIsFull = false
            while(!setIsFull){
                let artifact = newCollection[this.randomInteger(0,newCollection.length -1)];
                if(!this.isInArray(newSet,artifact)){
                    newSet.push(artifact);
                }
                if(newSet.length === 7){
                    setIsFull = true;
                }
            }
        }
        return newSet;
    }
    addRandomArtifactsToSet(){
        let newCollection = this.getAllUniqueCollection();
        let newSet = this.set;
        console.log(newCollection)
        if(newCollection.length >= 7){
            let setIsFull = false
            while(!setIsFull){
                let artifact = newCollection[this.randomInteger(0,newCollection.length -1)];
                if(!this.isInArray(newSet,artifact)){
                    newSet.push(artifact);
                }
                if(newSet.length === 7){
                    setIsFull = true;
                }
            }
        }
        return newSet;
    }
    getTextByCurrentLanguage(array){
        for(let i in array){
            if(array[i].language === LANGUAGE){
                return array[i].text;
            }
        }
        return '!EMPTY!';
    };
    getArtifactCountById(id){
        let count = 0;
        for(let i in this.collection){
            if(this.collection[i] == id)
                count++;
        }
        return count;
    }
    getArtifactsCountByQuality(quality){
        let count = 0;
        for(let i in this.collection){
            let artInfo = ATLAS.getArtifactInfoById(this.collection[i]);
            if(artInfo.quality == quality)
                count++;
        }
        return count;
    }
    trowERROR(text){
        alert('ERROR! '+text);
    }
    
    getArtifactsByQuality(quality){
        let array = [];
        for(let i in this.collection){
            let artInfo = ATLAS.getArtifactInfoById(this.collection[i]);
            if(artInfo.quality == quality)
                array.push(this.collection[i])
        }
        return array;
    }
    getRaitingPosition(){
        if(KEEPER.world){
            if(KEEPER.world.maxStricGreed){
                for(let i = 0; i < KEEPER.world.maxStricGreed.length;i++){
                    if(KEEPER.world.maxStricGreed[i].isSelf){
                       return KEEPER.world.maxStricGreed[i].position;
                    }
                }
            }
        }
        
        
        return 'false';
    }
    getLoginByRaitingPosition(pos){
        let position = 1;
        for(let i = 0; i < KEEPER.world.collectionWorthGreed.length;i++){
            if(position == pos){
                return KEEPER.world.collectionWorthGreed[i].user;
            }
            position++;
        }
        return false;
    }
    getArtifactTextInfo(typeId){
        if(!typeId) return '!EMPTY!';
        let artifactData = ATLAS.getArtifactInfoById(typeId);
        if(!artifactData) return '!EMPTY!';
        let actionsString = '';
        let count = 0;
        for(let i = 0;i < artifactData.actionsType.length;i++){
            let actionData = ATLAS.getActionTypesById(artifactData.actionsType[i]);
            if(actionData.isReal){
                if(count != 0)
                    actionsString += ' </n> '
                actionsString += this.getTextByCurrentLanguage(actionData.description);
                count++;
            }
            
        }
        return actionsString;//this.getTextByCurrentLanguage(artifactData.name)+'\n'+actionsString;//+'\n'+this.getTextByCurrentLanguage(artifactData.description);
    }
  
    getArtifactNameInfo(typeId){
        if(!typeId) return '!EMPTY!';
        let artifactData = ATLAS.getArtifactInfoById(typeId);
        if(!artifactData) return '!EMPTY!';
        return this.getTextByCurrentLanguage(artifactData.name);
    }
    getCollectionCost(){
        let cost = 0;
        for(let i in this.collection){
            let info = ATLAS.getArtifactInfoById(this.collection[i]);
            if(info.quality == 1){
                cost += info.quality;
            }else if(info.quality > 1){
                cost += (info.quality -1) *10;
            }
                
        }
        return cost;
    }   
    worldDataUpdate(data){
        this.world = data;
    }
    getUniqueCollectionCountByQuality(quality){
        let array = [];
        for(let i in this.collection){
            if(!this.isInArray(array,this.collection[i])){
                let artInfo = ATLAS.getArtifactInfoById(this.collection[i]);
                if(artInfo.quality == quality)
                    array.push(this.collection[i])
            }
        }
        return array.length;
    }
    getUniqueCollectionByQuality(quality){
        let array = [];
        for(let i in this.collection){
            if(!this.isInArray(array,this.collection[i])){
                let artInfo = ATLAS.getArtifactInfoById(this.collection[i]);
                if(artInfo.quality == quality)
                    array.push(this.collection[i])
            }
        }
        return array;
    }
    getUniqueCollectionByQualitySortedByCount(quality){
        let array = [];
        for(let i in this.collection){
            if(!this.isIdInArray(array,this.collection[i])){
                let artInfo = ATLAS.getArtifactInfoById(this.collection[i]);
                if(artInfo.quality == quality)
                    array.push({id:this.collection[i],count:this.getArtifactCountById(this.collection[i])})
            }
        }
        array.sort(this.sortByCountConverse);
        let returnArray = [];
        for(let i in array){
            returnArray.push(array[i].id);
        }
        return returnArray;
    }
    getUniqueCollectionSortedByCountAndQuality(){
        let array = [];
        for(let i in this.collection){
            if(!this.isIdInArray(array,this.collection[i])){
                let artInfo = ATLAS.getArtifactInfoById(this.collection[i]);
                array.push({id:this.collection[i],count:this.getArtifactCountById(this.collection[i]),quality:artInfo.quality})
            }
        }
        array.sort(this.sortByCountConverse);
        array.sort(this.sortByQuality);
        
        let returnArray = [];
        for(let i in array){
            returnArray.push(array[i].id);
        }
        return returnArray;
    }
    getAllUniqueCollectionCount(){
        let array = [];
        for(let i in this.collection){
            if(!this.isInArray(array,this.collection[i])){
                array.push(this.collection[i])
            }           
        }
        return array.length;
    }
    getAllUniqueCollection(){
        let array = [];
        for(let i in this.collection){
            if(!this.isInArray(array,this.collection[i])){
                array.push(this.collection[i])
            }           
        }
        return array;
    }
    isInArray(array,obj){
        for(let i in array){
            if(array[i] === obj)
                return true;
        }
        return false;
    }
    isIdInArray(array,id){
        for(let i in array){
            if(array[i].id === id)
                return true;
        }
        return false;
    }
    clearBattleData(){
        this.battle = {
            info: { 
                status: null,
                turnNumber: 0
            },
            data:{
                turnNumber:null,
                ourCreatures:[],
                ourArtifacts:[],
                enemyCreatures:[],
                enemyArtifacts:[],
            },
            result:{
                win:null,
                winner:null,
                winArtifacts:null,
                loseArtifacts:null,
                battleTime:null,
                getExperience:0,
            }
        };
    }
    battleEnemyDataUpdate(data){
        this.enemy = data;
    }
    getOurCardInCurrentBattleByPosition(position){
        for(let i in this.battle.data.ourCreatures){
            if(this.battle.data.ourCreatures[i]){
                if(this.battle.data.ourCreatures[i].position == position){
                    return this.battle.data.ourCreatures[i];
                }
            }
            
        }
    }
    getEnemyCardInCurrentBattleByPosition(position){
         //console.log(position)
        for(let i in this.battle.data.enemyCreatures){
            if(this.battle.data.enemyCreatures[i]){
                if(this.battle.data.enemyCreatures[i].position == position){
                    return this.battle.data.enemyCreatures[i];
                }
            }
        }
    }
    battleResoultUpdate(data){
        console.log('battleRes',data)
        this.battle.result.battleTime = data.battleTime;
        this.battle.result.winner = data.winner;
        this.battle.result.win = data.win;
        this.battle.result.winArtifacts = data.winArtifacts;
        this.battle.result.loseArtifacts = data.loseArtifacts;
        this.battle.result.getExperience = data.getExperience;
        
        this.battle.result.getCoins = data.getCoins;
    }
    battleDataUpdate(data){
        this.battle.data.turnNumber = data.turnNumber;
        this.battle.data.helpArtifactsId = data.helpArtifactsId;
        this.battle.data.helpCreaturesId = data.helpCreaturesId;
        let cardsCount = 5;
        let artifactsCount = 7;
        for(let i = 0 ; i < cardsCount ; i ++){
            this.battle.data.ourCreatures[i] = {
                id:data.ourCreaturesId[i],
                artifactId:data.ourCreaturesArtifactId[i],
                classId:data.ourCreaturesClass[i],
                raceId:data.ourCreaturesRace[i],
                position:data.ourCreaturesPosition[i],
                points:data.ourCreaturesPoints[i],
                isOpen:data.ourCreaturesIsOpen[i],
                typeId:data.ourCreaturesTypeId[i],
                classAbilityIsActive:data.ourCreaturesClassAbilityIsActive[i],
                raceAbilityIsActive:data.ourCreaturesRaceAbilityIsActive[i],
                shield:data.ourCreaturesHasShield[i],
                
            };
            this.battle.data.enemyCreatures[i] = {
                id:data.enemyCreaturesId[i],
                artifactId:data.enemyCreaturesArtifactId[i],
                classId:data.enemyCreaturesClass[i],
                raceId:data.enemyCreaturesRace[i],
                position:data.enemyCreaturesPosition[i],
                points:data.enemyCreaturesPoints[i],
                isOpen:data.enemyCreaturesIsOpen[i],
                typeId:data.enemyCreaturesTypeId[i],
                classAbilityIsActive:data.enemyCreaturesClassAbilityIsActive[i],
                raceAbilityIsActive:data.enemyCreaturesRaceAbilityIsActive[i],
                shield:data.enemyCreaturesHasShield[i],
            };
        }
        for(let i = 0 ; i < data.ourArtifactsId.length ; i ++){
      
            this.battle.data.ourArtifacts[i] = {
                id:data.ourArtifactsId[i],
                artifactTypeId:data.ourArtifactsTypeId[i],
                artifactIsUsable:data.ourArtifactsIsUsable[i]
            };
            
        }
        for(let i = 0 ; i < data.enemyArtifactsId.length ; i ++){
     
            this.battle.data.enemyArtifacts[i] = {
                id:data.enemyArtifactsId[i],
                artifactTypeId:data.enemyArtifactsTypeId[i],
                artifactIsUsable:data.enemyArtifactsIsUsable[i]
            };
            
            
        }
        /*
        for(let i = 0 ; i < artifactsCount ; i ++){
      
            this.battle.data.ourArtifacts[i] = {
                id:data.ourArtifactsId[i],
                artifactTypeId:data.ourArtifactsTypeId[i],
                artifactIsUsable:data.ourArtifactsIsUsable[i]
            };
            this.battle.data.enemyArtifacts[i] = {
                id:data.enemyArtifactsId[i],
                artifactTypeId:data.enemyArtifactsTypeId[i],
                artifactIsUsable:data.enemyArtifactsIsUsable[i]
            };
            
            
        }
        */
    }
    timersDataUpadate(data){
        this.timers = data;
    }
    userDataUpadate(data){
        this.user = data;
    }
    artifactsDataUpadate(data){
        this.collection = data.collection;
        this.set = data.set;

    }
    battleInfoDataUpadate(data){
        this.battle.info = data;
    }
    updateUser(data){
        this.dataBuffer.user = data;
        this.user.login = data.login;
    }
    updateBattle(data){
        this.dataBuffer.battle = data;
    }
    updateTurn(data){
        this.dataBuffer.turn = data;
    }
    updateEnemy(data){
        this.dataBuffer.enemy = data;
    }
    updateWarriors(data){
        this.dataBuffer.warriors = data;
    }
    updateEvents(data){
        this.dataBuffer.events = data;
    }
    isMissionAvailible(id){
        let mission = ATLAS.getMissionById(id);
        let complitedCount = 0;
        for(let i in mission.needComplite){
            for(let j in this.user.missions.completed){
                if(mission.needComplite[i] === this.user.missions.completed[j]){
                    complitedCount ++;
                }
            }
        }
        if(complitedCount === mission.needComplite.length){
            return true;
        }else{
            return false;
        }
    }
    isMissionComplite(id){
        for(let i in this.user.missions.completed){
            if(this.user.missions.completed[i] === id )
                return true;
        }
        return false;
    }
    isMissionPass(id){
        for(let i in this.user.missions.passed){
            if(this.user.missions.passed[i] === id )
                return true;
        }
        return false;
    }
    
    getFromArraybyId(id,array){
        for(let i in array){
            if(id == array[i].id)
                return array[i];
        }
        return false;
        
    }
    ///Добавление в чаты сообщения
    addStringToChat(message,sender,isPrivate){
        let chatSize = CHATMAXLENGTH;
        if(isPrivate){
            this.chat.private.push('['+new Date().getHours()+':'+new Date().getMinutes()+']'+sender+':'+message+'\n');
            if(this.chat.private.length > chatSize){
                this.chat.private.splice(0,1);
            }
        }
        this.chat.all.push('['+new Date().getHours()+':'+new Date().getMinutes()+']'+sender+':'+message+'\n');
        if(this.chat.all.length > chatSize){
            this.chat.all.splice(0,1);
        }
    }
    prepeareChatToString(type){
        let chat;
        switch(type){
            case 'all': chat = this.chat.all; break;
            case 'private': chat = this.chat.private; break;
        }
        let string = '';
        for(let i in chat){
            string += chat[i];
        }
      //  console.log(string)
        return string;
    }
    randomInteger(min, max) {
        var rand = min - 0.5 + Math.random() * (max - min + 1)
        rand = Math.round(rand);
        return rand;
    }
    ///Сортировка по id
    sortById(a,b){
        ///Сортировка по ворастанию
        if (a.id > b.id) return 1;
        if (a.id < b.id) return -1;
        return 0;
    }
    sortByCount(a,b){
        ///Сортировка по ворастанию
        if (a.count > b.count) return 1;
        if (a.count < b.count) return -1;
        return 0;
    }
    sortByCountConverse(a,b){
        ///Сортировка по ворастанию
        if (a.count < b.count) return 1;
        if (a.count > b.count) return -1;
        return 0;
    }
    sortByQualityConverse(a,b){
        ///Сортировка по ворастанию
        if (a.quality < b.quality) return 1;
        if (a.quality > b.quality) return -1;
        return 0;
    }
    sortByQuality(a,b){
        ///Сортировка по ворастанию
        if (a.quality > b.quality) return 1;
        if (a.quality < b.quality) return -1;
        return 0;
    }
    sortByIdConverse(a,b){
        ///Сортировка по ворастанию
        if (a.id < b.id) return 1;
        if (a.id > b.id) return -1;
        return 0;
    }
    ///Формат даты
    formatDateDMYHMS(date) {

      var dd = date.getDate();
      if (dd < 10) dd = '0' + dd;

      var mm = date.getMonth() + 1;
      if (mm < 10) mm = '0' + mm;

      var yy = date.getFullYear() % 100;
      if (yy < 10) yy = '0' + yy;
        
        var hh = date.getHours();
      if (hh < 10) hh = '0' + hh;
        
        var mn = date.getMinutes();
      if (mn < 10) mn = '0' + mn;
        
        var ss = date.getSeconds();
      if (ss < 10) ss = '0' + ss;

      return dd + '.' + mm + '.' + yy + ';' + hh + ':' +mn + ':' + ss;
    }
    ///Проверка столкновения двух прямоугольников
    checkCollision(obj1,obj2){
        
        
            /*
            //Левая, правая, верхняя, нижняя границы квадрата 1
            var x_a1 = obj1.Position.x;
            var x_a2 = x_a1 + obj1.Size.width;
            var y_a1 = obj1.Position.y;
            var y_a2 = y_a1 + obj1.Size.height;

            //Левая, правая, верхняя, нижняя границы квадрата 2
            var x_b1 = obj2.Position.x;
            var x_b2 = x_b1 + obj2.Size.width;
            var y_b1 = obj2.Position.y;
            var y_b2 = y_b1 + obj2.Size.height;
            */
            //Левая, правая, верхняя, нижняя границы квадрата 1
            var x_a1 = obj1.x - (obj1.width/2);
            var x_a2 = x_a1 + obj1.width;
            var y_a1 = obj1.y - (obj1.height/2);
            var y_a2 = y_a1 + obj1.height;
            //Левая, правая, верхняя, нижняя границы квадрата 2
            var x_b1 = obj2.x - (obj2.width/2);
            var x_b2 = x_b1 + obj2.width;
            var y_b1 = obj2.y - (obj2.height/2);
            var y_b2 = y_b1 + obj2.height;
            
            //Проверка пересечения прямоугольников
            if (x_a2>x_b1 && x_a1<x_b2 && y_a2>y_b1 && y_a1<y_b2) {
                //console.log("Прямоугольники пересекаются :)");
                return true;
            } else {
                //console.log("НЕТ пересечения :(");
                return false;
            }
    }
    ///Проверка столкновения двух прямоугольников
    checkCollisionDotInCircle(obj1,obj2){
        
        
            /*
            //Левая, правая, верхняя, нижняя границы квадрата 1
            var x_a1 = obj1.Position.x;
            var x_a2 = x_a1 + obj1.Size.width;
            var y_a1 = obj1.Position.y;
            var y_a2 = y_a1 + obj1.Size.height;

            //Левая, правая, верхняя, нижняя границы квадрата 2
            var x_b1 = obj2.Position.x;
            var x_b2 = x_b1 + obj2.Size.width;
            var y_b1 = obj2.Position.y;
            var y_b2 = y_b1 + obj2.Size.height;
            */
            //Левая, правая, верхняя, нижняя границы квадрата 1
            //var x_a1 = obj1.x - (obj1.width/2);
            //var x_a2 = x_a1 + obj1.width;
            //var y_a1 = obj1.y - (obj1.height/2);
            //var y_a2 = y_a1 + obj1.height;
            var xa = obj1.x;
            var ya = obj1.y;
            //Левая, правая, верхняя, нижняя границы квадрата 2
            var x_b1 = obj2.x - (obj2.width/2);
            var x_b2 = x_b1 + obj2.width;
            var y_b1 = obj2.y - (obj2.height/2);
            var y_b2 = y_b1 + obj2.height;
            
            //Проверка пересечения прямоугольников
            if (xa>x_b1 && xa<x_b2 && ya>y_b1 && ya<y_b2) {
                //console.log("Прямоугольники пересекаются :)");
                return true;
            } else {
                //console.log("НЕТ пересечения :(");
                return false;
            }
    }
    
   
}
